% Use of PhotonicCrystal
clear
% clc
close all

%% Definitions: numeric approximation
Calc.naMax = 160; % 160; NPp max UnitCellSide NVoxels <= naMax^3!
Calc.nDOS = 125; % 75; NPp reziprocal UnitCellSide for DOS, NVoxels = nDOS^3!
Calc.nGMax = 180; % 275; N G-vectors for calculation of w's size Mat = 2N x 2N
Calc.nDispersion = 250; % 250; n w-values Dispersion relation
Calc.yLimDispersion = [0 0.4*4*pi]; % empty -> auto
Calc.EmptyLatticeApproximation = 0;
Calc.plotReal = true; % Real space Unit Cell
Calc.plotFour = true; % Reciprocal Space Unit Cell
Calc.plotDispersion = true; % Dispersion Relation
Calc.plotDOS = true; % Density of States
Calc.saveplots = true; % automatic figure saving
Calc.save = true; % automatic set saving
Calc.name = 'diamond'; % Name of folder for results
Calc.mfilename = mfilename('fullpath');

%% Definitions: bravais lattice
Cell.Bravais = 'fcc';
Cell.e = 1; % e/e0 >= 1
Cell.a = 100; % [nm] conventional unit cell
Cell.b = 100; % [nm] conventional unit cell
Cell.c = 100; % [nm] conventional unit cell
Cell.alpha = 40; % [deg] conventional unit cell
Cell.beta =  90; % [deg] conventional unit cell
Cell.gamma = 60; % [deg] conventional unit cell
% Cell.Trace = 'GMKG'; % hex 2d
% Cell.Trace = 'GMXG'; % tetra 2d
% Cell.Trace = 'XGY';

%% Definitions: spheres in the primitive Unit Cell
% r = 0.5/sqrt(2);
r = 0.5*sqrt(3)/4;
Sphere(1).e = 13; % material e/e0 >= 1(vacuum)
Sphere(1).Radius = r; % [a] of  conventional unit cell
Sphere(1).M = [0 0 0]; % [a,b,c] of conventional unit cell

Sphere(2).e = 1; % material e/e0 >= 1(vacuum)
Sphere(2).Radius = r; % [a] of  conventional unit cell
Sphere(2).M = [.25 .25 .25]; % [a,b,c] of conventional unit cell

PhotonicCrystal(Cell,Sphere,Calc)



