function [ up,do,xx,yy,zz ] = Edges(x,y,z,r)
% function [ up,do ] = Edges(x,y,z,r )
%   Detailed explanation goes here

nx = size(x,1);
ny = size(x,2);
nz = size(x,3);

%% rotation of Edgepoints
R = RMat3(r,[0 0 1]);

%% 6 planes of the cell
A(1).ID = @(x,y,z) sum(([1 1 x x;1 y y 1;1 1 1 1]'-[0 1 1]).*[1 x x*y],2);
A(2).ID = @(x,y,z) sum(([1 1 1 1;1 1 y y;1 z z 1]'-[0 1 1]).*[1 x x*y],2);
A(3).ID = @(x,y,z) sum(([1 x x 1;1 1 1 1;1 1 z z]'-[0 1 1]).*[1 x x*y],2);
A(4).ID = @(x,y,z) sum(([1 1 x x;y y y y;1 z z 1]'-[0 1 1]).*[1 x x*y],2);
A(5).ID = @(x,y,z) sum(([x x x x;1 y y 1;1 1 z z]'-[0 1 1]).*[1 x x*y],2);
A(6).ID = @(x,y,z) sum(([1 x x 1;1 1 y y;z z z z]'-[0 1 1]).*[1 x x*y],2);

PlaneOrnt = NaN(size(A));
if nargout > 2
    xx = NaN(4,numel(A));
    yy = NaN(4,numel(A));
    zz = NaN(4,numel(A));
end

for k = 1:numel(A) % koordinates of the edges
    A(k).ID = A(k).ID(nx,ny,nz); % Index
    A(k).Plane = [x(A(k).ID) y(A(k).ID) z(A(k).ID)]; % plane
    if nargout>2
        xx(:,k) = A(k).Plane(:,1);
        yy(:,k) = A(k).Plane(:,2);
        zz(:,k) = A(k).Plane(:,3);
    end
    A(k).Plane = A(k).Plane*R; % rotation
    o = cross(A(k).Plane(1,:)-A(k).Plane(2,:),...
        A(k).Plane(3,:)-A(k).Plane(2,:));
    PlaneOrnt(k) = o(end);
end

ID = find(PlaneOrnt < 0);
up = NaN(6*numel(ID),3);
for k = 1:numel(ID)
    idw = (k-1)*6;
    idr = ID(k);
    up(idw+1:idw+4,:) = A(idr).Plane;
    up(idw+5,:) = A(idr).Plane(1,:); % closed plane
end

ID = find(PlaneOrnt > 0);
do = NaN(6*numel(ID),3);
for k = 1:numel(ID)
    idw = (k-1)*6;
    idr = ID(k);
    do(idw+1:idw+4,:) = A(idr).Plane;
    do(idw+5,:) = A(idr).Plane(1,:); % closed plane
end

% %% 90 rotation
% up = [-1 1 1] .* up(:,[2,1,3]);
% do = [-1 1 1] .* do(:,[2,1,3]);

end

