function [ R ] = RMat3( a,b )
% function [ R ] = RMat3( a,b )
% rotation matrix to rotate vector a to vector b

a = a/sqrt(a*a'); % unit vector
b = b/sqrt(b*b'); % unit vector

u = cross(b,a); % rotation axis
u = u/sqrt(u*u'); % unit vector
if vecnorm(u) > 1e-8
    phi = acos(b*a'); % rotation angle
    R = cos(phi)*eye(3) + sin(phi)*[0 -u(3) u(2);u(3) 0 -u(1);-u(2) u(1) 0] + (1-cos(phi))*u'*u;
else
    R = a*b'*eye(3);
end


end

