function [ xx,yy,zz ] = Space( x,y,z,xa,ya,za )
%SPACE Summary of this function goes here
%   Detailed explanation goes her

    if nargin < 5
        ya = xa;
        za = xa;
    end

    nx = numel(xa);
    ny = numel(ya);
    nz = numel(za);
    
    x = orientate(x,1);
    y = orientate(y,2);
    z = orientate(z,3);
    
    xa = orientate(xa,1);
    ya = orientate(ya,2);
    za = orientate(za,3);
    
    xx = zeros(nx,ny,nz) + xa.*x(1) + ya.*y(1) + za.*z(1);
    yy = zeros(nx,ny,nz) + xa.*x(2) + ya.*y(2) + za.*z(2);
    zz = zeros(nx,ny,nz) + xa.*x(3) + ya.*y(3) + za.*z(3);
end

function x = orientate(x,dim)
    switch dim
        case 1
            x = x(:); % first dimension
        case 2
            x = x(:)'; % second dimension
        case 3
            x = reshape(x,1,1,numel(x)); % third dimension
    end
end

