function [ xx,yy,zz ] = WignerSeitz( a1,a2,a3 )
%WIGNERSEITZ Summary of this function goes here
%   Detailed explanation goes here
n = 2;
N = (2*n+1)^3;
X = zeros(N,3);

l=1;
for i=-n:n
    for j=-n:n
        for k=-n:n
            X(l,:)=i*a1+j*a2+k*a3;
            l=l+1;
        end
    end
end


% Compute Voronoi diagram.
[c,v] = voronoin(X);

nx = c(v{(N+1)/2},:);
tri = convhulln(nx);
ntri = size(tri,1);

xi = NaN(3,ntri);
yi = NaN(3,ntri);
zi = NaN(3,ntri);
for k = 1:ntri
    xi(:,k) = nx(tri(k,:),1);
    yi(:,k) = nx(tri(k,:),2);
    zi(:,k) = nx(tri(k,:),3);
end
xm = mean(xi,1);
ym = mean(yi,1);
zm = mean(zi,1);

xx = NaN(8,ntri); % max 8 Ecken ...
yy = NaN(8,ntri);
zz = NaN(8,ntri);
k = 1;
while size(xi,2) > 0
    nvec = cross([xi(1,1)-xi(2,1),yi(1,1)-yi(2,1),zi(1,1)-zi(2,1)],...
        [xi(3,1)-xi(2,1),yi(3,1)-yi(2,1),zi(3,1)-zi(2,1)]);
    nvec = nvec/norm(nvec);
    d = -(nvec(1)*xi(1,1)+nvec(2)*yi(1,1)+nvec(3)*zi(1,1));
    IDplane = abs(nvec(1)*xm+nvec(2)*ym+nvec(3)*zm+d)<abs(1e-6*d);
    R = RMat3(nvec,[0 0 1]);
    x = xi(:,IDplane);
    y = yi(:,IDplane);
    z = zi(:,IDplane);
    
    xi(:,IDplane) = []; % clear Points
    yi(:,IDplane) = [];
    zi(:,IDplane) = [];
    xm(IDplane) = [];
    ym(IDplane) = [];
    zm(IDplane) = [];
    
    Pxy = [x(:),y(:),z(:)]*R;
    alpha = atan2(Pxy(:,2),Pxy(:,1));
    [alpha,IDsort] = sort(alpha);
    IDdelete = find(alpha(2:end)-alpha(1:end-1) == 0);
    IDsort(IDdelete) = []; % clear double points
    np = numel(IDsort);
    xx(1:np,k) = x(IDsort);
    yy(1:np,k) = y(IDsort);
    zz(1:np,k) = z(IDsort);
    xx(np+1:end,k) = xx(1,k);
    yy(np+1:end,k) = yy(1,k);
    zz(np+1:end,k) = zz(1,k);
    k = k+1;
end
xx(:,k:end) = [];
yy(:,k:end) = [];
zz(:,k:end) = [];

end

