function [ ] = mkpdf(fig,pathname,filename,typ)
% function [ ] = mkpdf(fig,pathname,filename,typ)
%
% Funktion speichert Grafik fig als pdf ab
% typ:  std (default)
%
% fig = figure('OuterPosition',[x,y,l,b],'PaperPositionMode','auto');

if nargin < 4
    typ = 'std';
end

if ~strcmp(pathname(end),'/')
    pathname = [pathname,'/'];
end

filename = strrep(filename,'.pdf','');


if ~isdir(pathname) % Falls Ordner noch angelegt werden muss
    mkdir(pathname)
end

% fig.InvertHardcopy = 'off';


switch typ
%     case 'export_fig'
%         export_fig([pathname,filename],'-pdf','-transparent',fig)
%     case 'savefigure'
%         savefigure([pathname,filename],'pdf')
    case 'std'
        print(fig, '-depsc2', [pathname,filename]); % eps erstellen
        e2p = which('epstopdf.exe');
        if ~isempty(e2p)
            system(['"',e2p,'" "',pathname,filename,'.eps"']); % eps in pdf konvertieren
            delete([pathname,filename,'.eps']) % eps lschen
        else
            warning('"epstopdf.exe" not found, mkpdf generates .eps-files!')
        end
    otherwise
        error('typ falsch')
end

end

