function [e_] = polvec(k)
N = size(k,1);
er = randn(N,3);

% Loop until a vector is found which is not parallel to k:
ID = sum(er == k,2) == 3;
if sum(ID)
    while sum(ID)
        er(ID) = randn(sum(ID),3);
        ID = sum(er == k,2) == 3;
    end
end

e_ = NaN(2*N,3);
e_(1:N,:) = cross(k,er);
e_(1:N,:) = e_(1:N,:)./vecnorm(e_(1:N,:));
IDnan = isnan(e_(1:N,1));
e_(N+1:end,:) = cross(k,e_(1:N,:));
e_(N+1:end,:) = e_(N+1:end,:)./vecnorm(e_(N+1:end,:));
if sum(IDnan)
    IDnan = find(IDnan);
    e_(IDnan,:) = ones(numel(IDnan),1)*[1 0 0]; % any
    e_(IDnan+N,:) = ones(numel(IDnan),1)*[0 1 0]; % any
end


ID = dot(cross(e_(1:N,:),e_(N+1:end,:)),k,2)<0; % Check right-hand character
if sum(ID)
    e_(ID,:) = -e_(ID,:);
end

